#version 400

in vec2 texCoords;

out vec4 color;

// color lookup table for particles, depending on their color
vec3 colorLUT[39] = vec3[](
    vec3(0.02745098039215686274, 0.02745098039215686274, 0.02745098039215686274),
    vec3(0.12156862745098039215, 0.02745098039215686274, 0.02745098039215686274),
    vec3(0.18431372549019607843, 0.05882352941176470588, 0.02745098039215686274),
    vec3(0.27843137254901960784, 0.05882352941176470588, 0.02745098039215686274),
    vec3(0.34117647058823529411, 0.09019607843137254901, 0.02745098039215686274),
    vec3(0.40392156862745098039, 0.12156862745098039215, 0.02745098039215686274),
    vec3(0.46666666666666666666, 0.12156862745098039215, 0.02745098039215686274),
    vec3(0.56078431372549019607, 0.15294117647058823529, 0.02745098039215686274),
    vec3(0.62352941176470588235, 0.18431372549019607843, 0.02745098039215686274),
    vec3(0.68627450980392156862, 0.24705882352941176470, 0.02745098039215686274),
    vec3(0.74901960784313725490, 0.27843137254901960784, 0.02745098039215686274),
    vec3(0.78039215686274509803, 0.27843137254901960784, 0.02745098039215686274),
    vec3(0.87450980392156862745, 0.30980392156862745098, 0.02745098039215686274),
    vec3(0.87450980392156862745, 0.30980392156862745098, 0.02745098039215686274),
    vec3(0.87450980392156862745, 0.34117647058823529411, 0.02745098039215686274),
    vec3(0.87450980392156862745, 0.34117647058823529411, 0.02745098039215686274),
    vec3(0.84313725490196078431, 0.37254901960784313725, 0.02745098039215686274),
    vec3(0.84313725490196078431, 0.40392156862745098039, 0.05882352941176470588),
    vec3(0.81176470588235294117, 0.43529411764705882352, 0.05882352941176470588),
    vec3(0.81176470588235294117, 0.46666666666666666666, 0.05882352941176470588),
    vec3(0.81176470588235294117, 0.49803921568627450980, 0.05882352941176470588),
    vec3(0.81176470588235294117, 0.52941176470588235294, 0.09019607843137254901),
    vec3(0.78039215686274509803, 0.52941176470588235294, 0.09019607843137254901),
    vec3(0.78039215686274509803, 0.56078431372549019607, 0.09019607843137254901),
    vec3(0.78039215686274509803, 0.59215686274509803921, 0.12156862745098039215),
    vec3(0.74901960784313725490, 0.62352941176470588235, 0.12156862745098039215),
    vec3(0.74901960784313725490, 0.62352941176470588235, 0.12156862745098039215),
    vec3(0.74901960784313725490, 0.65490196078431372549, 0.15294117647058823529),
    vec3(0.74901960784313725490, 0.65490196078431372549, 0.15294117647058823529),
    vec3(0.74901960784313725490, 0.68627450980392156862, 0.18431372549019607843),
    vec3(0.71764705882352941176, 0.68627450980392156862, 0.18431372549019607843),
    vec3(0.71764705882352941176, 0.71764705882352941176, 0.18431372549019607843),
    vec3(0.71764705882352941176, 0.71764705882352941176, 0.21568627450980392156),
    vec3(0.87450980392156862745, 0.87450980392156862745, 0.62352941176470588235),
    vec3(0.81176470588235294117, 0.81176470588235294117, 0.43529411764705882352),
    vec3(0.81176470588235294117, 0.81176470588235294117, 0.43529411764705882352),
    vec3(0.93725490196078431372, 0.93725490196078431372, 0.78039215686274509803),
    vec3(1.00000000000000000000, 1.00000000000000000000, 1.00000000000000000000),
    vec3(1.00000000000000000000, 1.00000000000000000000, 1.00000000000000000000)
);

uniform sampler2D tex;
uniform uint particleTemp;

void main() {
    color = texture(tex, texCoords.xy) * vec4(colorLUT[particleTemp], 1.);
}
